import { APIGatewayProxyStructuredResultV2 } from "aws-lambda";
import { IdTokenClaims, Issuer } from "openid-client";
export interface OidcConfig {
    clientID: string;
    issuer: Issuer;
    onSuccess: (claims: IdTokenClaims) => Promise<APIGatewayProxyStructuredResultV2>;
}
declare module "./provider.js" {
    interface Adapters {
        oidc: typeof OidcAdapter;
    }
}
export declare const OidcAdapter: {
    handle: (config: OidcConfig) => Promise<APIGatewayProxyStructuredResultV2>;
};
